Index: src/Makefile.global.in
===================================================================
RCS file: /projects/cvsroot/pgsql-server/src/Makefile.global.in,v
retrieving revision 1.161
diff -p -u -r1.161 Makefile.global.in
--- src/Makefile.global.in	2003/04/04 20:42:11	1.161
+++ src/Makefile.global.in	2003/04/15 16:59:41
@@ -177,6 +177,9 @@ ifeq ($(GCC), yes)
   CFLAGS += -Wall -Wmissing-prototypes -Wmissing-declarations
 endif
 
+JAVAC	= javac
+
+
 # Kind-of compilers
 
 YACC = @YACC@
Index: src/interfaces/jdbc/Makefile
===================================================================
RCS file: /projects/cvsroot/pgsql-server/src/interfaces/jdbc/Makefile,v
retrieving revision 1.38
diff -p -u -r1.38 Makefile
--- src/interfaces/jdbc/Makefile	2003/02/12 06:13:04	1.38
+++ src/interfaces/jdbc/Makefile	2003/04/15 16:59:41
@@ -22,9 +22,10 @@ build.properties: $(top_builddir)/src/Ma
 	@echo fullversion=$(VERSION) >> build.properties
 	@echo def_pgport=$(DEF_PGPORT) >> build.properties
 	@echo enable_debug=$(enable_debug) >> build.properties
+	@echo build.compiler=$(JAVAC) >> build.properties
 